#ifndef Lib_FunctionManager_h
#define Lib_FunctionManager_h

// Inheritance :
#include <Slash/Data/IFunction.h>
#include <Slash/Core/IManager.h>
#include <Slash/Data/IFunctionManager.h>

#include <list>

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Core {class IWriter;}}

#include <Lib/Value.h>

namespace Lib {

class FunctionManager 
:public virtual Slash::Core::IManager 
,public virtual Slash::Data::IFunctionManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //IFunctionManager
  virtual Slash::Data::IFunction* findFunction(const std::string&);
  virtual bool load(const std::string&,const std::string& = "");
public:
  FunctionManager(Slash::Core::ISession&);
  virtual ~FunctionManager();
public:
  typedef std::vector<Lib::Value> FunctionArgs;
  static bool find_f77_functions(const std::string& file,
                                 std::vector<std::string>& names,
                                 std::vector<FunctionArgs>& args,
                                 Slash::Core::IWriter& printer);
  static bool edit_f77_file(const std::string& file,
                            const std::string& new_file,
                            const std::vector<std::string>& names,
                            const std::vector<FunctionArgs>& args);
private:
  bool loadF77(const std::string&,const std::string& = "");
  bool loadC(const std::string&,const std::string& = "");
  Slash::Data::IFunction* addFunction(const std::string&,
                                      const std::string&,
                                      void*,
                                      const std::vector<Lib::Value>& args,
                                      unsigned int);
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  std::list<Slash::Data::IFunction*> fList;
};

}

#endif




