// this :
#include <OnXTemplateSix/VisProcessor.h>

// Slash :
#include <Slash/UI/IUI.h>
#include <Slash/Core/ISession.h>

// Lib :
#include <Lib/Out.h>

// OnX :
#include <OnX/Core/Main.h>

// this :
#include <OnXTemplateSix/FrameworkManager.h>

//////////////////////////////////////////////////////////////////////////////
OnXTemplateSix::VisProcessor::VisProcessor(
 User::Framework& aFramework
)
:User::Processor(aFramework)
,fOnX(0)
,fUI(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> args;
  fOnX = new OnX::Main(false,false,args);
  if(!fOnX->isValid()) {
    delete fOnX;
    fOnX = 0;
    return;
  }

  Slash::Core::ISession* session = fOnX->session();
  if(!session) return;

  // Declare our Manager to the OnX session.
  // It must be done prior the creation of the UI in order 
  // that the OnXTemplateSix_initialize callbacks execute properly).
  OnXTemplateSix::FrameworkManager* frameworkManager = 
    new OnXTemplateSix::FrameworkManager(&aFramework,false);
  session->addManager(frameworkManager);

  std::string onxFile = 
    "$ONXTEMPLATESIXROOT/scripts/OnX/OnXTemplateSix.onx";

  fUI = fOnX->createUI("",onxFile,true);
  if(!fUI) {
    Lib::Out out(session->printer());
    out << "OnXTemplateSix::VisProcessor::VisProcessor :"
        << " UI not created."
        << Lib::endl;
  }

}

//////////////////////////////////////////////////////////////////////////////
OnXTemplateSix::VisProcessor::VisProcessor(
 const VisProcessor& aFrom
)
:User::Processor(aFrom)
,fOnX(0)
,fUI(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}

//////////////////////////////////////////////////////////////////////////////
OnXTemplateSix::VisProcessor::~VisProcessor(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fOnX;
}
//////////////////////////////////////////////////////////////////////////////
OnXTemplateSix::VisProcessor& OnXTemplateSix::VisProcessor::operator=(
 const VisProcessor&
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fOnX = 0;
  fUI = 0;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Slash::Core::ISession* OnXTemplateSix::VisProcessor::session(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fOnX) return 0;
  return fOnX->session();
}
//////////////////////////////////////////////////////////////////////////////
bool OnXTemplateSix::VisProcessor::isValid(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fUI) return false;
  return fUI->isValid();
}
//////////////////////////////////////////////////////////////////////////////
void OnXTemplateSix::VisProcessor::processEvent(
 const User::Event&
) 
//////////////////////////////////////////////////////////////////////////////
// Someone get out of the below steer() by doing a UI.exit()
// from some "Next event" button in the GUI.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fUI) return;
  fUI->executeScript("DLD","OnXTemplateSix OnXTemplateSix_clear");
  fUI->executeScript("DLD","OnXTemplateSix OnXTemplateSix_vis_tracks");
  fUI->steer();
}
